var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import finalizeType from '../parse/finalize-type';
import parseType from '../parse/parse-type';
import SimpExp from 'simpexp';
import { pathToStr } from '../utils';

export default function validate(baseType, validation) {
  function Validate(options) {
    var self = { options: options },
        type = _extends({}, parseType(_extends({}, options, { self: options.self }), baseType)),
        origValidator = type.validateAssign,
        typeMoniker = options.typeMoniker,
        regExp = void 0,
        origDefault = void 0,
        defaultValue = void 0;

    if (validation instanceof RegExp) {
      regExp = validation;
      defaultValue = new SimpExp(validation).gen();
      origDefault = type.defaultValue;
      type.defaultValue = function () {
        var value = origDefault();
        return regExp.test(value) ? value : defaultValue;
      };
      validation = function validation(value) {
        return regExp.test(value) ? null : 'Must match ' + String(regExp);
      };
    }

    type.validateAssign = function (value, instancePath) {
      var instanceName = pathToStr(instancePath || typeMoniker),
          message = void 0;

      try {
        message = validation(value);
      } catch (err) {
        message = err.message;
      }
      if (message === true) {
        message = null;
      }
      if (message) {
        return 'Can\'t assign "' + instanceName + '": ' + message;
      } else {
        return origValidator(value, instancePath);
      }
    };

    if (type.origPack) {
      type.pack = type.origPack;
      type.origPack = undefined;
    }

    return _extends(self, finalizeType(type));
  }

  Validate.isType = true;
  return Validate;
}