var freeze = Object.freeze ? Object.freeze.bind(Object) : function () {};

export default function packVerify(type) {
  type.origPack = type.pack;
  type.pack = function (value) {
    var options = type.options,
        packed = void 0;
    if (options.validate) {
      var message = type.validateAssign(value);
      if (message) {
        throw new TypeError(message);
      }
    }
    packed = type.origPack(value);
    if (options.freeze) {
      freeze(packed);
    }
    return packed;
  };
}