var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import parseType from '../parse/parse-type';
import collection from './collection';

export default function collections(models) {
  function Collections(options) {
    var thisType = { options: options, isCollections: true },
        type = void 0;

    type = {
      get models() {
        var _this = this;

        var result = {};
        models.forEach(function (model) {
          return result[model.modelName] = _this[model.collection].model;
        });
        return result;
      }
    };

    models.forEach(function (model) {
      return type[model.collection] = collection(model)(options);
    });

    _extends(thisType, parseType(_extends({}, options, { self: thisType }), type));
    thisType.name = 'collections(' + models.map(function (model) {
      return model.modelName;
    }).join(', ') + ')';
    thisType.collections = models.map(function (model) {
      return type[model.collection];
    });
    return thisType;
  }

  Collections.isType = true;
  return Collections;
}