'use strict';

exports.__esModule = true;
exports.type = exports.autoResolve = exports.wrapGenerator = exports.reducer = exports.bare = exports.validate = exports.optional = exports.makeOwner = exports.model = exports.collections = exports.collection = exports.ObjectId = exports.reference = exports.Nil = exports.Any = exports.tuple = exports.union = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _union = require('./types/union');

Object.defineProperty(exports, 'union', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_union)['default'];
  }
});

var _tuple = require('./types/tuple');

Object.defineProperty(exports, 'tuple', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_tuple)['default'];
  }
});

var _any = require('./types/any');

Object.defineProperty(exports, 'Any', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_any)['default'];
  }
});

var _nil = require('./types/nil');

Object.defineProperty(exports, 'Nil', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_nil)['default'];
  }
});

var _reference = require('./types/reference');

Object.defineProperty(exports, 'reference', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_reference)['default'];
  }
});

var _objectId = require('./types/object-id');

Object.defineProperty(exports, 'ObjectId', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_objectId)['default'];
  }
});

var _collection = require('./types/collection');

Object.defineProperty(exports, 'collection', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_collection)['default'];
  }
});

var _collections = require('./types/collections');

Object.defineProperty(exports, 'collections', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_collections)['default'];
  }
});

var _model = require('./types/model');

Object.defineProperty(exports, 'model', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_model)['default'];
  }
});
Object.defineProperty(exports, 'makeOwner', {
  enumerable: true,
  get: function get() {
    return _model.makeOwner;
  }
});

var _optional = require('./modifiers/optional');

Object.defineProperty(exports, 'optional', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_optional)['default'];
  }
});

var _validate = require('./modifiers/validate');

Object.defineProperty(exports, 'validate', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_validate)['default'];
  }
});

var _bare = require('./modifiers/bare');

Object.defineProperty(exports, 'bare', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_bare)['default'];
  }
});

var _reducer = require('./modifiers/reducer');

Object.defineProperty(exports, 'reducer', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_reducer)['default'];
  }
});

var _wrapGenerator = require('./modifiers/wrap-generator');

Object.defineProperty(exports, 'wrapGenerator', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_wrapGenerator)['default'];
  }
});

var _autoResolve = require('./modifiers/auto-resolve');

Object.defineProperty(exports, 'autoResolve', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_autoResolve)['default'];
  }
});

var _type = require('./parse/type');

Object.defineProperty(exports, 'type', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_type)['default'];
  }
});
exports['default'] = reduxSchemaStore;

var _store = require('./store');

var _store2 = _interopRequireDefault(_store);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function reduxSchemaStore(schema, options, createStore, preloadedState, enhancer) {
  var result = function result(createStore) {
    return function (reducer, preloadedState, enhancer) {
      var store = new _store2['default'](_extends({ schema: schema }, options)),
          redux = void 0;

      if (preloadedState !== undefined) {
        var message = store.schema.validateData(preloadedState);
        if (message) throw new TypeError('Can\'t use preloaded state: ' + message);
      }

      if (reducer) {
        (function () {
          var customReducer = reducer;
          reducer = function reducer(state, action) {
            return customReducer(store.reducer(state, action), action);
          };
        })();
      } else {
        reducer = store.reducer;
      }

      redux = createStore(reducer, preloadedState, enhancer);

      store.getState = redux.getState;
      store.replaceReducer = redux.replaceReducer;
      store.subscribe = redux.subscribe;

      store.store = redux;

      return store;
    };
  };

  return createStore ? result(createStore)(null, preloadedState, enhancer) : result;
}