'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports['default'] = validate;

var _finalizeType = require('../parse/finalize-type');

var _finalizeType2 = _interopRequireDefault(_finalizeType);

var _parseType = require('../parse/parse-type');

var _parseType2 = _interopRequireDefault(_parseType);

var _simpexp = require('simpexp');

var _simpexp2 = _interopRequireDefault(_simpexp);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function validate(baseType, validation) {
  function Validate(options) {
    var self = { options: options },
        type = _extends({}, (0, _parseType2['default'])(_extends({}, options, { self: options.self }), baseType)),
        origValidator = type.validateAssign,
        typeMoniker = options.typeMoniker,
        regExp = void 0,
        origDefault = void 0,
        defaultValue = void 0;

    if (validation instanceof RegExp) {
      regExp = validation;
      defaultValue = new _simpexp2['default'](validation).gen();
      origDefault = type.defaultValue;
      type.defaultValue = function () {
        var value = origDefault();
        return regExp.test(value) ? value : defaultValue;
      };
      validation = function validation(value) {
        return regExp.test(value) ? null : 'Must match ' + String(regExp);
      };
    }

    type.validateAssign = function (value, instancePath) {
      var instanceName = (0, _utils.pathToStr)(instancePath || typeMoniker),
          message = void 0;

      try {
        message = validation(value);
      } catch (err) {
        message = err.message;
      }
      if (message === true) {
        message = null;
      }
      if (message) {
        return 'Can\'t assign "' + instanceName + '": ' + message;
      } else {
        return origValidator(value, instancePath);
      }
    };

    if (type.origPack) {
      type.pack = type.origPack;
      type.origPack = undefined;
    }

    return _extends(self, (0, _finalizeType2['default'])(type));
  }

  Validate.isType = true;
  return Validate;
}