'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _templateObject = _taggedTemplateLiteralLoose(['\n            function(){\n              return new ', '\'(...arguments);\n            }'], ['\n            function(){\n              return new ', '\'(...arguments);\n            }']);

exports['default'] = collection;

var _utils = require('../utils');

var _parseType = require('../parse/parse-type');

var _parseType2 = _interopRequireDefault(_parseType);

var _model = require('./model');

var _bare = require('../modifiers/bare');

var _bare2 = _interopRequireDefault(_bare);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _taggedTemplateLiteralLoose(strings, raw) { strings.raw = raw; return strings; }

function collection(model, extraProperties) {
  if (!model.isModel) {
    throw new TypeError('Collection items must be Models');
  }
  function Collection(options) {
    var self = { options: options, isCollection: true },
        typeMoniker = options.typeMoniker,
        parentMoniker = typeMoniker.slice(0, -1),
        modelType = model(_extends({}, options, {
      typeMoniker: parentMoniker.concat(model.modelName),
      parent: options.self || self,
      self: null
    })),
        type = {
      '*': modelType,
      create: (0, _bare2['default'])((0, _utils.namedFunction)('create' + modelType.name, function () {
        return this.model.apply(null, arguments);
      }), (0, _utils.dedent)(_templateObject, modelType.name), !options.namedFunctions),
      get all() {
        var _this = this;

        return this.keys.map(function (id) {
          return _this.get(id);
        });
      },
      get model() {
        var self = this,
            BoundModel = (0, _utils.namedFunction)(modelType.name, function Model() {
          for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          return modelType.call.apply(modelType, [this, (0, _model.makeOwner)(self)].concat(args));
        }, modelType, !options.debug);
        BoundModel.prototype = modelType.prototype;
        _extends(BoundModel, modelType);
        return BoundModel;
      },
      remove: function remove(id) {
        if (id && id._meta && id._meta.idKey && id[id._meta.idKey]) {
          id = id[id._meta.idKey];
        }
        var val = this.get(id);
        if (!val) throw new Error('Could not remove ' + modelType.name + '[' + id + ']: object not found');
        this.set(id, undefined);
      }
    },
        thisType = void 0;

    if (extraProperties) {
      type = _extends({}, extraProperties, type);
    }

    thisType = (0, _parseType2['default'])(_extends({}, options, { self: self }), type);

    thisType.name = 'collection(' + modelType.name + ')';
    thisType.collection = model.collection;
    thisType.model = modelType;
    return _extends(self, thisType);
  }

  Collection.isType = true;
  return Collection;
}