'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports['default'] = collections;

var _parseType = require('../parse/parse-type');

var _parseType2 = _interopRequireDefault(_parseType);

var _collection = require('./collection');

var _collection2 = _interopRequireDefault(_collection);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function collections(models) {
  function Collections(options) {
    var thisType = { options: options, isCollections: true },
        type = void 0;

    type = {
      get models() {
        var _this = this;

        var result = {};
        models.forEach(function (model) {
          return result[model.modelName] = _this[model.collection].model;
        });
        return result;
      }
    };

    models.forEach(function (model) {
      return type[model.collection] = (0, _collection2['default'])(model)(options);
    });

    _extends(thisType, (0, _parseType2['default'])(_extends({}, options, { self: thisType }), type));
    thisType.name = 'collections(' + models.map(function (model) {
      return model.modelName;
    }).join(', ') + ')';
    thisType.collections = models.map(function (model) {
      return type[model.collection];
    });
    return thisType;
  }

  Collections.isType = true;
  return Collections;
}