'use strict';

exports.__esModule = true;
exports['default'] = tuple;

var _parseObject = require('../parse/parse-object');

var _parseObject2 = _interopRequireDefault(_parseObject);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function tuple() {
  for (var _len = arguments.length, types = Array(_len), _key = 0; _key < _len; _key++) {
    types[_key] = arguments[_key];
  }

  if (!types.length) throw new TypeError('Tuple requires item types.');

  if (types.length === 1) {
    if (!types[0] || !(0, _utils.isArray)(types[0]) || types[0].length < 2) throw new TypeError('Tuple requires multiple item types.');
    types = types[0];
  }

  function Tuple(options) {
    var type = (0, _parseObject2['default'])(options, types, true);

    type.name = 'tuple(' + Object.keys(type.properties).map(function (prop) {
      return type.properties[prop].kind;
    }).join(', ') + ')';
    return type;
  }

  Tuple.isType = true;
  return Tuple;
}